#
# monkey patch Camping to work with rack-flash
#
# include the CampingFlash module in TheApp
#
# => Use ClassName.instance_eval to define class methods.
# => Use ClassName.class_eval to define instance methods.
#

# http://stackoverflow.com/questions/1766741/comparing-ruby-hashes
=begin
class Hash
  def diff(other)
    self.keys.inject({}) do |memo, key|
      unless self[key] == other[key]
        memo[key] = [self[key], other[key]] 
      end
      memo
    end
  end
=end

module CampingFlash
  
  def self.included(base)
    # self is CampingFlash
    # base is TheApp
    Camping::H.class_eval <<-EOT
      def diff(other)
        self.keys.inject({}) do |memo, key|
          unless self[key] == other[key]
            memo[key] = [self[key], other[key]] 
          end
          memo
        end
      end
    EOT
  end

  def to_a #:nodoc:
    if @state.respond_to? :diff
      diff = @_state.diff(@state)
      diff.each {|k,v| @env['rack.session'].delete(k) }
    end
    #super
    until_to_a_gets_into_camping
  end

  def until_to_a_gets_into_camping #:nodoc:
    # overwrite the session with how @state is now
    # depeding on whether diff is defined for H or not
    if @state.respond_to? :diff
      @env['rack.session'].merge! Hash[@state]
    else
      @env['rack.session'] = Hash[@state]
    end
    r = Rack::Response.new(@body, @status, @headers)
    @cookies._n.each do |k, v|
      r.set_cookie(k, v)
    end
    r.to_a
  end

  def initialize(env, m) #:nodoc:
    super(env,m)
    @_state = @state.clone
  end
    
end

#Camping::Cookies[r.cookies], SimpleDelegator.new(Camping::H)[r.session.to_hash],