
# doc (look up rdoc)

require 'lazy'

class Endless
  include Enumerable
  
  def initialize
    make_a_promise Lazy.promise &Proc.new
  end
  
  def make_a_promise(p)
    @p = p
  end

  def get_promise
    @p
  end
  
  def each
    p = get_promise
    a = []
    while p
      car, cdr = p
      head_by_tail = car[1]
      a << head_by_tail
      yield head_by_tail
      p = cdr.get_promise
    end
    a
  end

  def map
    p = get_promise
    a = []
    while p
      car, cdr = p
      head_by_tail = car[1]
      a << (yield head_by_tail)
      p = cdr.get_promise
    end
    a
  end

end

def endless_path(head, tail=1) # needs to start at 1 cuz head*1 = head (should be identity product)
    Endless.new { [[tail, head * tail], endless_path(head, tail+1)] }
end