require 'logger'
require 'singleton'

class ContextLogger < Logger
  
  include Singleton
  
  def self.format_block # implicit
    the_proc = Proc.new # capture it
    context = eval("Context::determine{}", the_proc) # eval can take a Proc obj or a Binding
    result = the_proc.call # invoke it
    klass = 'nil' # can it be??
    # puts context[:self].inspect
    if context[:self]
      klass = context[:self].class.to_s.split('::').last
      if klass == "Object"; klass = 'main' end
    end
    if context[:function]
      if klass
        context = "#{context[:location]} #{klass}.#{context[:function]}()"
      else
        context = "#{context[:location]} #{context[:function]}()"
      end
    else
      context = "#{context[:location]} #{klass}@#{context[:line_number]}"
    end
    case result
    when String # maybe respond_to? is better but meh ...
      return "[#{context}]: #{result}" # time stamp
    else
      return "[#{context}]: #{result.inspect}"
    end
  end

  %w(debug info warn error fatal).each do |sev|
    method = sev.to_sym
    class_eval <<-EOT, __FILE__, __LINE__
      def #{method}(msg=nil, &block)
        if block
          output = ContextLogger.format_block(&block)
          super(@progname){output}
        else
          super(msg)
        end
      rescue
        $stderr.puts "Oh deary me. Error in ContextLogger: "+$!.inspect
      end
    EOT
  end
  
  def initialize(stream=STDOUT)
    # DEBUG < INFO < WARN < ERROR < FATAL < UNKNOWN
    level=Logger::DEBUG
    super(stream)
  end

end

$L = ContextLogger.instance