require 'tilt'
require 'tilt/template'

# prefer Erubis
# http://www.kuwata-lab.com/erubis/
# require 'erubis'
# Tilt.register :erb, Tilt[:erubis]
# Tilt.register :rhtml, Tilt[:erubis]

require 'neo'

module Tilt
  # ClearSilver implementation. See:
  # my https://github.com/igravious/clearsilver gist
  class ClearSilverTemplate < Tilt::Template
    
    def self.engine_initialized?
      # defined? ::ClearSilver
      defined? ::Neo::Cs
    end

    def initialize_engine
      #require_template_library 'neo' # not thread-safe apparently
    end

    class << self
      attr_accessor 'old_api'
      def old_api? ; old_api end
      # old_api = true <--- does not work !!!
    end

    ClearSilverTemplate.old_api = false
 
    attr_accessor 'additive_parsing'
    def additive_parsing? ; additive_parsing end
    
    def debug # implicit
      if $DEBUG and $L
        $L.debug(&Proc.new) # pass it along
      end
    end
    
    def prepare
      # data comes from tilt
      debug { "#0" }
      unless data.length.zero?
      debug { "#1" }
        @data = data
        @engine = nil
        @output = nil
        @already_parsed = false
        @additive_parsing = false
      end
    end
    
    def evaluate(scope, locals, &block)

      debug { scope }
      debug { locals }
      debug { block }
      if block
        hd = block.call
        #obj = scope
        #method = :fooish
        debug { scope.methods.sort }
        e = scope.instance_variable_get(:@env)
        debug {e}
        m = scope.instance_variable_get(:@method)
        debug {m}
        pack = [e, m]
        obj, method = scope.class.respond_to?(:parent) ? [scope.class.parent, :dispatch] : [nil, nil]
        debug {[obj, method]}
      else
        hd = scope
        obj = nil
      end
      if ClearSilverTemplate.old_api
      debug { "#2" }
        @engine = Neo::Cs.new hd unless @engine # CS Ruby API, traditional
        if !@already_parsed or additive_parsing?
      debug { "#2.5" }
          # boooooh, can't be a singleton cuz of parse_string
          # either way, only do it once per tilt/cs obj, unless you don't wanna
          @already_parsed = true
          @engine.parse_string @data # CS C API
        end
      else
      debug { "#3" }
        @engine = Neo::Cs.new # CS Ruby API, revamped
        @engine.use hd # CS Ruby/C API
        if obj
          @engine.register_fileload(obj, method, pack)
          # @engine.register_fileload(obj, method, locals) # call before parse_x, should use splat
        end
        @engine.parse_string @data # CS C API
      end
      @output = @engine.render locals[:locale] 
      # @output = @engine.render locals[:locale] # it's actually called render in CS C API
    end

   end
end

Tilt.register Tilt::ClearSilverTemplate, 'cshtml'
